/*********************************************************************************
  *Copyright(C),2015-2021, 
  *TUYA 
  *www.tuya.com
  *FileName:    tuya_ipc_alsa_play_demo.h
**********************************************************************************/
#ifndef _TUYA_IPC_ALSA_PLAY_DEMO_H_
#define _TUYA_IPC_ALSA_PLAY_DEMO_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#if defined(DEMO_IPC_VOICE_ENABLE) && (DEMO_IPC_VOICE_ENABLE == 1)
#include <stdio.h>
#include <alsa/asoundlib.h>
#include "tuya_ipc_media_wave_parse.h"

typedef struct ty_alsa_play_handle {
        snd_pcm_t           *handle;
        snd_pcm_uframes_t   period_size;
        INT_T               period_data_size;
        UINT_T              channels;
        UINT_T              rate;
        USHORT_T            bytes_per_sample;
} ty_alsa_play_handle_s;

/* init alsa play interface */
ty_alsa_play_handle_s *ty_alsa_play_init(ty_media_wav_s *wav);

/* uninit alsa play interface */
VOID ty_alsa_play_uninit(ty_alsa_play_handle_s **play_handle);

/* play data by alsa interface */
INT_T ty_alsa_play_data(ty_alsa_play_handle_s *play_handle, CHAR_T *pData, INT_T len);

/* set volume by alsa interface */
INT_T ty_alsa_set_volume(INT_T volume);
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
