/*********************************************************************************
  *Copyright(C),2015-2021, 
  *TUYA 
  *www.tuya.com
  *FileName:    tuya_ipc_media_wave_parse.h
**********************************************************************************/
#ifndef _TUYA_IPC_MEDIA_WAVE_PARSE_H_
#define _TUYA_IPC_MEDIA_WAVE_PARSE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#if defined(DEMO_IPC_VOICE_ENABLE) && (DEMO_IPC_VOICE_ENABLE == 1)
#include <stdio.h>

typedef struct _wav_riff_t {
    UCHAR_T         id[4];              //ID: "RIFF"
    UINT_T          size;               //file_len - 8
    UCHAR_T         type[4];            //type:"WAVE"
} ty_wav_riff_s;

typedef struct _wav_format_t {
    UCHAR_T         id[4];              //ID: "fmt"
    UINT_T          size;
    USHORT_T        compression_code;
    USHORT_T        channels;
    UINT_T          samples_per_sec;
    UINT_T          avg_bytes_per_sec;
    USHORT_T        block_align;
    USHORT_T        bits_per_sample; 
} ty_wav_format_s;

typedef struct _wav_fac_t {
    UCHAR_T         id[4];
    UINT_T          size;
} ty_wav_fact_s;

typedef struct _wav_dat_t {
    UCHAR_T         id[4];
    UINT_T          size;
} ty_wav_data_s;

typedef struct _wav_id_header_t {
    UCHAR_T         id[4];
    UINT_T          size;
} ty_wav_id_header_s;

typedef struct _wav_t {
    FILE*           fp;
    ty_wav_riff_s   riff;
    ty_wav_format_s format;
    ty_wav_fact_s   fact;
    ty_wav_data_s   data;
    UINT_T          file_size;
    UINT_T          data_offset;
    UINT_T          data_size;
} ty_media_wav_s;

ty_media_wav_s *ty_media_wav_open(CHAR_T *file_name);

VOID ty_media_wav_close(ty_media_wav_s **wav);

VOID ty_media_wav_dump(ty_media_wav_s *wav);

INT_T ty_media_wav_check(CHAR_T *file_name);
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
