/*********************************************************************************
  *Copyright(C),2015-2021, 
  *TUYA 
  *www.tuya.com
  *FileName:    tuya_ipc_speaker_demo.h
**********************************************************************************/
#ifndef _TUYA_IPC_SPEAKER_DEMO_H_
#define _TUYA_IPC_SPEAKER_DEMO_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#if defined(DEMO_IPC_VOICE_ENABLE) && (DEMO_IPC_VOICE_ENABLE == 1)
#include <stdio.h>

#define IPC_WAV_FILENAME_LEN   256

typedef enum {
    IPC_SPEAKER_STATUS_IDLE      = 0,
    IPC_SPEAKER_STATUS_INIT      = 1,
    IPC_SPEAKER_STATUS_PLAYING   = 2,
    IPC_SPEAKER_STATUS_PAUSING   = 3,
    IPC_SPEAKER_STATUS_ERR       = 4
} IPC_SPEAKER_STATUS_E;

/* get speaker status */
IPC_SPEAKER_STATUS_E ty_speaker_get_status();

/* play wav file */
INT_T ty_speaker_play_file(CHAR_T          *filename);

/* pause speaker playing */
INT_T ty_speaker_pause_file();

/* stop speaker playing */
INT_T ty_speaker_stop_file();

/* set speaker volume */
INT_T ty_speaker_set_volume(INT_T volume);
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
