/*********************************************************************************
  *Copyright(C),2015-2021, 
  *TUYA 
  *www.tuya.com
  *FileName:    tuya_ipc_voice_demo.h
**********************************************************************************/
#ifndef _TUYA_IPC_VOICE_DEMO_H_
#define _TUYA_IPC_VOICE_DEMO_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#if defined(DEMO_IPC_VOICE_ENABLE) && (DEMO_IPC_VOICE_ENABLE == 1)
#include <stdio.h>

typedef enum {
    IPC_VOICE_PLAY_CTRL_PLAY         = 0,
    IPC_VOICE_PLAY_CTRL_PAUSE        = 1,
    IPC_VOICE_PLAY_CTRL_STOP         = 2,
    IPC_VOICE_PLAY_CTRL_NEXT         = 3,
    IPC_VOICE_PLAY_CTRL_PREV         = 4
} IPC_VOICE_PLAY_CONTROL_E;

typedef enum {
    IPC_VOICE_PLAY_MODE_LOOP         = 0,
    IPC_VOICE_PLAY_MODE_LOOP1        = 1,
    IPC_VOICE_PLAY_MODE_SHUFFLE      = 2
} IPC_VOICE_PLAY_MODE_E;

/* set play for TUYA_DP_VOICE_PLAY */
OPERATE_RET ty_voice_set_play(CHAR_T *code, INT_T id);

/* set play_control for TUYA_DP_VOICE_PLAY_CONTROL */
OPERATE_RET ty_voice_set_play_control(IPC_VOICE_PLAY_CONTROL_E cmd);

/* get play_mode for TUYA_DP_VOICE_PLAY_MODE */
INT_T ty_voice_get_play_mode();

/* set play_mode for TUYA_DP_VOICE_PLAY_MODE */
OPERATE_RET ty_voice_set_play_mode(IPC_VOICE_PLAY_MODE_E mode);

/* get play_volume for TUYA_DP_VOICE_PLAY_VOLUME */
INT_T ty_voice_get_play_volume();

/* set play_volume for TUYA_DP_VOICE_PLAY_VOLUME */
OPERATE_RET ty_voice_set_play_volume(INT_T volume);

/* update voice list for TUYA_DP_VOICE_UPGRADE */
OPERATE_RET ty_voice_set_update_voice_list();

/* get play_state for TUYA_DP_VOICE_PLAY_STATE */
INT_T ty_voice_get_play_state();

OPERATE_RET TUYA_APP_Enable_Voice();
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
