/**
 * @file tkl_ota.c
 * @brief default weak implements of tuya ota, it only used when OS=linux
 * 
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 * 
 */
#include "tkl_ota.h"
#include "tuya_error_code.h"

/**
 * @brief ota packet download start inform
 * 
 * @param[in] file_size the size of the ota packet
 * 
 * @return OPRT_OK on success, others on failed
 *
 */
TUYA_WEAK_ATTRIBUTE OPERATE_RET tkl_ota_start_notify(UINT_T image_size, TKL_OTA_TYPE_E type)
{
    return OPRT_OK;
}

/**
 * @brief ota packet data process
 * 
 * @param[in] total_len ota the total length of the ota packet
 * @param[in] offset the data offset in ota packet
 * @param[in] data ota the data
 * @param[in] len the data length
 * @param[out] remain_len the remain length of the data
 * @param[in] pri_data reserved
 *
 * @return OPRT_OK on success, others on failed
 *
 */
TUYA_WEAK_ATTRIBUTE OPERATE_RET tkl_ota_data_process(TKL_OTA_DATA_T *pack, UINT_T* remain_len)
{
    return OPRT_OK;
}

/**
 * @brief firmware ota packet transform success inform, can do verify in this funcion
 * 
 * @param[in]        reset       need reset or not
 * 
 * @return OPRT_OK on success, others on failed
 */
TUYA_WEAK_ATTRIBUTE OPERATE_RET tkl_ota_end_notify(TKL_OTA_RESULT_E reset)
{
    return OPRT_OK;
}

